;loads entire specified bitmap file into allocated memory and replaces
;old bitmap
;
;object:
;DWORD [obj] = VTable
;DWORD [obj+4] = n/a
;DWORD [obj+8] = ADDRESS of bitmap name/path
;DWORD [obj+12] = X Position for bitmap's upper-left corner
;DWORD [obj+16] = Y Position for bitmap's upper-left corner
;DWORD [obj+20] = X Position for bitmap's lower-right corner
;DWORD [obj+24] = Y Position for bitmap's lower-right corner
;ADDR [obj+28]  = usual address for bitmap string name
;
;Local variables:
;DWORD [ebp-4] = bitmap's file handle
;DWORD [ebp-8] = file size
;DWORD [ebp-12] = temp number of bytes read
;DWORD [ebp-16] = temp address of newly allocated mem

struct CAT102
       lpVTable 		dd	?
       refCount 		dd	?
       lpBitmapFN		dd	?
       XPosCornerUL		dd	?
       YPosCornerUL		dd	?
       XPosCornerLR		dd	?
       YPosCornerLR		dd	?
       lpBitmapStringName	dd	?
ends

align 16
;==========================================================
AT102MAIN:
;==========================================================
push ebp
mov ebp,esp
sub esp,20
push ebx
push edi
push esi
mov edx,ecx
mov [ebp-4], DWORD 0
	mov esi,[edx+8]
	test esi,esi
	     jz ExitBMPLoad_102

;--------------- append bitmap name to full path (temporarily)
mov edi,MapsDirBuffer
add edi,[MapsPathSize]
    AppendBMPNameLoop_102:
    mov al,[esi]
	cmp al,'"'		;" character
	    jz EndAppendBMPNameLoop_102
	test al,al
	     jz EndAppendBMPNameLoop_102
    mov [edi],al		;transfer/append string
    inc edi
    inc esi
    jmp AppendBMPNameLoop_102
EndAppendBMPNameLoop_102:
mov BYTE [edi],0		;add null-terminator
;---------------
mov edi,edx

invoke CreateFile,MapsDirBuffer,GENERIC_READ,0,0,OPEN_EXISTING,\
			FILE_ATTRIBUTE_NORMAL,0
	mov ecx,[MapsPathSize]
	mov BYTE [ecx+MapsDirBuffer],0	   ;restore path's null-terminator
	test eax,eax
	     jz ExitBMPLoad_102
	cmp eax,-1
	    jz ExitBMPLoad_102
	mov [ebp-4],eax

invoke SetFilePointer,eax,0,0,FILE_BEGIN
	cmp eax,-1
	    jz ExitBMPLoad_102

invoke GetFileSize,DWORD [ebp-4],0
	cmp eax,-1
	    jz ExitBMPLoad_102

mov DWORD [ebp-8],eax
mov [BUFSIZE_map_bitmap],eax

invoke LocalAlloc,LMEM_FIXED,eax
	test eax,eax
	     jz ExitBMPLoad_102
	mov [ebp-16],eax	;store new address

lea ecx,[ebp-12]
invoke ReadFile, DWORD [ebp-4],eax,DWORD [ebp-8],ecx,0
	test eax,eax
	     jz ExitBMPLoad_102_2
	mov eax,[ebp-12]
	cmp eax,[ebp-8]
	    jnz ExitBMPLoad_102_2

mov eax,[ebp-8] 		;bitmap size
mov ecx,[ebp-16]		;bitmap in memory
cmp [ecx+2],eax 		;is BMP size entry in file same as file size?
    jnz ExitBMPLoad_102_2

mov eax,[ebp-16]
add eax,14			;point to BITMAPINFOHEADER/BITMAPCOREHEADER
cmp DWORD [eax],12		;is BITMAPCOREHEADER w/16-bit values?
    jz BITMAPCOREHEADER_found_102
				;if not, is BITMAPINFOHEADER
	mov ecx,[eax+4] 	;and size values are 32-bit
	mov [bitmapwidth],ecx
	mov ecx,[eax+8]
	mov [bitmapheight],ecx
	jmp SetVars_102

BITMAPCOREHEADER_found_102:
	xor ecx,ecx
	mov cx,[eax+4]
	mov [bitmapwidth],ecx
	mov cx,[eax+6]
	mov [bitmapheight],ecx
;-------------------- calculate scale values and store data
SetVars_102:

mov eax,[edi+12]
mov [anchorXvalue],eax		;save values and calculate scales

fld DWORD [edi+20]		;XPos for upper-left
fsub DWORD [edi+12]		;minus XPos for lower-right
fild [bitmapwidth]		;convert to integer, put in st0
fdivp st1,st0			;calculate X scale (float diff./width in pixels)
fstp [scaleXvalue]		;may be negative

mov eax,[edi+16]
mov [anchorYvalue],eax

fld DWORD [edi+24]		;YPos for upper-left
fsub DWORD [edi+16]		;minus YPos for lower-right
fild [bitmapheight]		;convert to integer, put in st0
fdivp st1,st0			;calculate Y scale (float diff./width in pixels)
fstp [scaleYvalue]		;may be negative

push edi
;--------------- copy bitmap name to buffer (for later saving)
mov esi,[edi+8] 	     ;put name in esi
mov edx,CURRENT_MAP_BUFFER
	MOVE_LOOP_1_102:
	mov al,[esi]
	cmp al,'"'
	    jz ENDMOVE_LOOP_1_102
	test al,al
	     jz ENDMOVE_LOOP_1_102
	mov [edx],al
	inc esi
	inc edx
	jmp MOVE_LOOP_1_102
ENDMOVE_LOOP_1_102:
mov BYTE [edx],0
;--------------- copy four position values (for later saving)
	lea esi,[edi+12]
	mov edi,CURRENT_MAP_VALUES
	mov ecx,4
	rep movsd
;--------------------
pop edi

LOCALRELEASE [currentbitmap]  ;unload old map if existing

mov eax,[ebp-16]
mov [currentbitmap],eax 	;store new bitmap address
jmp Success_BMPLoad_102
;--------------------------------------
ExitBMPLoad_102_2:
invoke LocalFree,DWORD [ebp-16]

ExitBMPLoad_102:
	CLOSEHANDLE DWORD [ebp-4]
xor eax,eax
pop esi
pop edi
pop ebx
mov esp,ebp
pop ebp
ret

Success_BMPLoad_102:
	mov [MapLoadSuccess_BOOL],TRUE
	invoke CloseHandle, DWORD [ebp-4]
or eax,1
pop esi
pop edi
pop ebx
mov esp,ebp
pop ebp
ret

align 16
;==========================================================
AT102_REINIT:
;==========================================================
mov eax,[esp+4] 	;standard
ret 4

align 16
;====================================================================
_AT102Init:
;====================================================================

GETVALUE Sample,0		;get bitmap "Sample" string first
sub esp,4
mov edi,esp
SETVALUE value_string,1
pop edi 			;edi=pointer to string (if valid)
test eax,eax
     jz NoNewActionType 	;leave if no valid string

mov ebx,edi
FINDSTRINGEND ebx
sub ebx,edi
    jz NoNewActionType		;0 length?
inc ebx 			;ebx=string length (w/null terminator)
mov [ebp-4],edi 		;string addr start

cmp ebx,80
    ja NoNewActionType		;LIMIT STRING LENGTH TO 80 BYTES


lea edx,[ebx+28]		;28 for object, the rest for string

ALLOCAT edx
lea eax,[AT102]
mov [edi],eax
    xor eax,eax
    lea edx,[edi+28]
mov [edi+4],eax
mov [edi+8],edx
mov [edi+12],eax
mov [edi+16],eax
mov [edi+20],eax
mov [edi+24],eax

MOVESTRING [edi+28],[ebp-4],ebx

GETVALUE XPos,1
SETVALUE value_float,4

GETVALUE YPos,2
SETVALUE value_float,5

GETVALUE X,3
SETVALUE value_float,6

GETVALUE Y,4
SETVALUE value_float,7

	jmp ExitINAT