;============================================================
;CBackDrop Instance Collector
;============================================================
;optimized for lower counts in CBackDrop instances

;============================================================
INTERCEPTPROC CBACKDROPCOLLECTMAIN	;must preserve eax,esi,edi,ebx,ebp
;============================================================
push esi
push edi
push ebx
mov ebx,eax

	mov ecx,[CBACKDROP_instancecount]
	test ecx,ecx
	     jnz CBACKDROPCOLLECT_NONEWBUFFER
	     invoke LocalAlloc,LMEM_FIXED,(CBACKDROP_BUFFER_INSTCOUNT_INITIAL*4)
	     test eax,eax
		  jz CBACKDROPCOLLECTMAIN_EXIT
	     mov [CBACKDROP_buffer],eax
	     mov [CBACKDROP_buffercapacity],CBACKDROP_BUFFER_INSTCOUNT_INITIAL
	     jmp CBACKDROPCOLLECT_ADDINSTANCE
	CBACKDROPCOLLECT_NONEWBUFFER:

	cmp ecx,[CBACKDROP_buffercapacity]
	    jb CBACKDROPCOLLECT_ADDINSTANCE
	    add ecx,CBACKDROP_BUFFER_INSTCOUNT_INITIAL
	    shl ecx,2
	    invoke LocalAlloc,LMEM_FIXED,ecx	     ;create new buffer
	    test eax,eax
	    mov edi,eax
		 jz CBACKDROPCOLLECTMAIN_EXIT
	    mov esi,[CBACKDROP_buffer]
	    mov ecx,[CBACKDROP_instancecount]	    ;copy old buffer to new
	    mov [CBACKDROP_buffer],edi
	    add [CBACKDROP_buffercapacity],CBACKDROP_BUFFER_INSTCOUNT_INITIAL
	    rep movsd
	CBACKDROPCOLLECT_ADDINSTANCE:

	mov eax,[CBACKDROP_buffer]
	mov ecx,[CBACKDROP_instancecount]
	mov [eax+4*ecx],ebx		      ;add instance to buffer
	inc ecx
	mov [CBACKDROP_instancecount],ecx

CBACKDROPCOLLECTMAIN_EXIT:
mov eax,ebx
pop ebx
pop edi
pop esi
add esp,0C0h		 ;REPLACED CODE
ret

;============================================================
CBACKDROPBUFFERRELEASE:
;============================================================
	xor ecx,ecx
	mov eax,[CBACKDROP_buffer]
	mov [CBACKDROP_instancecount],ecx
	mov [CBACKDROP_buffer],ecx
	test eax,eax
	mov [CBACKDROP_buffercapacity],ecx
	     jz NO_CBACKDROPBUFFERRELEASE
	invoke LocalFree,eax

NO_CBACKDROPBUFFERRELEASE:
ret

;============================================================
CBACKDROPFINDINSTANCEFROMID:  ;eax=stringID of instance to find
;============================================================
;returns instance in eax or NULL
push ebx

	mov ecx,[CBACKDROP_instancecount]
	mov ebx,[CBACKDROP_buffer]
	test ecx,ecx
	     jz NO_CBACKDROPFINDINSTANCEFROMID

	CBACKDROPFINDINSTANCEFROMID_LOOP:
	mov edx,[ebx]
	cmp eax,[edx+CInstance.InstanceNameID]
	    jz CBACKDROPFINDINSTANCEFROMID_FOUND
	add ebx,4
	loop CBACKDROPFINDINSTANCEFROMID_LOOP
	NO_CBACKDROPFINDINSTANCEFROMID:
	xor eax,eax

pop ebx
ret

CBACKDROPFINDINSTANCEFROMID_FOUND:
	mov eax,edx
pop ebx
ret


