;============================================================
;CLASS OUTPUTTER (ALPHA) CODE
;============================================================
;EDIT: INCOMPLETE
;
;does not take into account free-ing of instances

;============================================================
COutP_Init:
;============================================================

	call COutP_Release

	mov eax,[COutP_MaxInstanceCount]
	test eax,eax
	     jz COutP_Init_EXIT
	shl eax,3		;* 8 = size (in bytes)
	invoke LocalAlloc,LPTR,eax
	test eax,eax
	mov [COutP_MainBuffer],eax
	     jz COutP_Init_EXIT

	mov [COutP_ACTIVE],TRUE

COutP_Init_EXIT:
ret

;============================================================
COutP_Release:
;============================================================
	mov [COutP_ACTIVE],FALSE
	mov [COutP_CurrInstanceCount],0
	LOCALRELEASE [COutP_MainBuffer]

ret

;============================================================
INTERCEPTPROC VirtualAllocInstanceMemIntercept
;============================================================
;size of mem at [esp+4], instance mem in esi (must preserve)

cmp [COutP_ACTIVE],FALSE
    jz NO_VirtualAllocInstanceMemIntercept
test esi,esi
     mov edi,[esp+0Ch]		;size of instance
     jz NO_VirtualAllocInstanceMemIntercept

     stdcall COutP_AddToBuffer,esi,edi

NO_VirtualAllocInstanceMemIntercept:
;REPLACED CODE (6 bytes):
pop edi
mov eax,esi
pop esi
ret

;============================================================
INTERCEPTPROC HeapAllocYAPAXIInstanceMemIntercept
;============================================================
;size of mem at [esp+4], must call YAPAXI to allocate

cmp [COutP_ACTIVE],FALSE
    jz NO_HeapAllocYAPAXIInstanceMemIntercept

    push DWORD [esp+4]
    call [YAPAXI]	   ;returns mem address in eax
    add esp,4
    test eax,eax
	 jz NO_HeapAllocYAPAXIInstanceMemIntercept_2

	 push eax
	 mov edx,[esp+8]       ;instance size
	 stdcall COutP_AddToBuffer,eax,edx
	 pop eax

NO_HeapAllocYAPAXIInstanceMemIntercept_2:
ret


NO_HeapAllocYAPAXIInstanceMemIntercept:
    jmp [YAPAXI]

;============================================================
INTERCEPTPROC VirtualFreeInstanceMemIntercept
;============================================================
cmp [COutP_ACTIVE],FALSE
    jz No_VirtualFreeInstanceMemIntercept
      push DWORD [esp+4]
      call COutP_RemoveFromBuffer
No_VirtualFreeInstanceMemIntercept:
jmp DWORD [VirtualFree]

;============================================================
INTERCEPTPROC HeapAllocFreeInstanceMemIntercept
;============================================================
cmp [COutP_ACTIVE],FALSE
    jz No_HeapAllocFreeInstanceMemIntercept
      push DWORD [esp+4]
      call COutP_RemoveFromBuffer
No_HeapAllocFreeInstanceMemIntercept:
jmp DWORD [free]

;============================================================
COutP_UpdateBuffer:
;============================================================
;checks instances in buffer, removes dead instances and non-instance buffers
;moves buffer instances in buffer while doing so (to keep list
;valid until search point)
push edi
push esi
push ebx

	mov esi,[COutP_MainBuffer]
	mov ebx,[COutP_CurrInstanceCount]
	test ebx,ebx
	     jz COutP_UpdateBuffer_MAINLOOP_EXIT
	lea ebx,[esi+ebx*4]

	COutP_UpdateBuffer_MAINLOOP:
	mov edi,[esi]		      ;edi = instance
	mov ecx,[COutP_MaxInstanceCount]
	shl ecx,2
	mov eax,[ecx+esi]	      ;eax = instance's original size
	stdcall IsValidInstance,edi,eax
	test eax,eax
	     jnz COutP_UpdateBuffer_MAINLOOP_SKIP     ;LAST TEST - if valid, jump and leave instance untouched

	COutP_UpdateBuffer_MAINLOOP_InstanceInvalid:  ;invalid
	     ;if invalid, nullify instance (satisfies special cases, i.e., instance last in list)
	     ;and replace with one currently at end of list. Also, decrement ESI for loop
	     ;and move instance's size.

	      mov ecx,[COutP_CurrInstanceCount]
	      mov edx,[COutP_MainBuffer]
	      shl ecx,2

	      lea edx,[ecx+edx-4]    ;edx points to last instance
	      mov DWORD [esi],0      ;nullify instance reference (takes care of case where instance is last in buffer)

	      mov ecx,[COutP_MaxInstanceCount]
	      mov eax,[edx]	     ;get last instance
	      shl ecx,2
	      mov [esi],eax	     ;replace null reference with new instance (or null if last instance in list or only instance in list)

	      mov eax,[edx+ecx]      ;get last instance's size
	      dec [COutP_CurrInstanceCount]
	      mov [esi+ecx],eax      ;move last instance's size

	      sub esi,4
	      sub ebx,4

	COutP_UpdateBuffer_MAINLOOP_SKIP:
	add esi,4
	cmp esi,ebx
	    jb COutP_UpdateBuffer_MAINLOOP

	COutP_UpdateBuffer_MAINLOOP_EXIT:
pop ebx
pop esi
pop edi
ret


;============================================================
COutP_AddToBuffer:	;[esp+4] = instance to add to buffer (if not full), [esp+8] = instance size
;============================================================
;simply appends instance to current end of list and places
;instance size in corresponding location in second half of buffer
	mov ecx,[COutP_CurrInstanceCount]
	mov edx,[COutP_MaxInstanceCount]
	cmp ecx,edx
	    jnb COutP_AddToBuffer_FULL
	mov eax,[esp+4] 	;instance
	shl ecx,2
	shl edx,2
	add ecx,[COutP_MainBuffer]
	mov [ecx],eax
	mov eax,[esp+8] 	;instance size
	add ecx,edx
	inc [COutP_CurrInstanceCount]
	mov [ecx],eax
	COutP_AddToBuffer_FULL:
ret 8

;============================================================
COutP_RemoveFromBuffer:      ;[esp+4] = instance to remove from buffer (if present)
;============================================================
;finds instance to remove, and if present, removes reference
;from list and replaces with the ones currently at the end
;of the list (simulates moving the list down - order unimportant).
;Must also move transfered instance's instance size.
push edi
	mov ecx,[COutP_CurrInstanceCount]
	mov eax,[esp+8]
	test ecx,ecx
	mov edi,[COutP_MainBuffer]
	    jz COutP_RemoveFromBuffer_EXIT
	repne scasd	  ;find instance
	      jne COutP_RemoveFromBuffer_EXIT	 ;did we find the instance?
	      ;if so, we replace the instance with the one at the end
	      ;of the buffer (last entered), so there are no empty spaces
	      ;(will be null if it was last instance or if buffer empty)

	      mov ecx,[COutP_CurrInstanceCount]
	      mov edx,[COutP_MainBuffer]
	      shl ecx,2

	      sub edi,4
	      lea edx,[ecx+edx-4]    ;edx points to last instance
	      mov DWORD [edi],0      ;nullify instance reference (takes care of case where instance is last in buffer)

	      mov ecx,[COutP_MaxInstanceCount]
	      mov eax,[edx]	     ;get last instance
	      shl ecx,2
	      mov [edi],eax	     ;replace null reference with new instance (or null if last instance in list or only instance in list)

	      mov eax,[edx+ecx]      ;get last instance's size
	      dec [COutP_CurrInstanceCount]
	      mov [edi+ecx],eax      ;move last instance's size

	COutP_RemoveFromBuffer_EXIT:
pop edi
ret 4

;============================================================
COutP_Print:		;assumes there are more than a few instances in buffer
;============================================================
cmp [EnableClassOutputter],FALSE
    jz COutP_Print_EXIT
cmp [COutP_ACTIVE],FALSE
    jz COutP_Print_EXIT
cmp [COutP_MainBuffer],0
    jz COutP_Print_EXIT
cmp [COutP_CurrInstanceCount],0
    jz COutP_Print_EXIT

push ebp
mov ebp,esp
sub esp,40
push esi	 ;main loop pointer
push edi	 ;sub-loop pointer
push ebx	 ;current instance (first of this type found)

;[ebp-4] = main loop end limit
;[ebp-8] = current instance size
;[ebp-12] = temp var
;[ebp-32] = tresclasses.cdd file
;[ebp-36] = tresclasses.cdd file size
;[ebp-40] = pointer to tresclasses.cdd memory

	mov [COutP_ACTIVE],FALSE
	mov [COutP_FileHandle],0
	call COutP_UpdateBuffer

	mov edi,[PathStringSize]
	mov esi,CDD_filename
	add edi,StringBuffer
	call TransferString

	xor eax,eax
	mov [ebp-32],eax
	mov [ebp-40],eax
invoke CreateFile,StringBuffer,GENERIC_READ+GENERIC_WRITE,0,0,OPEN_EXISTING,\
		  FILE_ATTRIBUTE_NORMAL,0
	mov ecx,[PathStringSize]
	cmp eax,-1
	mov BYTE [ecx+StringBuffer],0
	    jz COutP_Print_EXIT_B
	mov [ebp-32],eax

invoke GetFileSize,eax,0
	cmp eax,-1
	mov [ebp-36],eax
	    jz COutP_Print_EXIT_B
	cmp eax,(sizeof.outfile_header+sizeof.vtable_desc)
	    jna COutP_Print_EXIT_B

invoke SetFilePointer,[ebp-32],0,0,FILE_BEGIN
	cmp eax,-1
	    jz COutP_Print_EXIT_B

	mov eax,[ebp-36]
	add eax,CLASS_OUTPUTTER_OUTFILE_EXT_SIZE
invoke LocalAlloc,LPTR,eax
	test eax,eax
	mov [ebp-40],eax
	     jz COutP_Print_EXIT_B

	lea edx,[ebp-12]
invoke ReadFile,[ebp-32],eax,[ebp-36],edx,0
	test eax,eax
	mov eax,[ebp-12]
	     jz COutP_Print_EXIT_B
	cmp eax,[ebp-36]
	    jnz COutP_Print_EXIT_B

	mov edx,[ebp-40]
	cmp [edx+outfile_header.Name],'COTP'
	    jnz COutP_Print_EXIT_B
	;eax = size

	cmp [edx+outfile_header.FileEndOffset],eax
	    jnz COutP_Print_EXIT_B

	cmp DWORD [edx+outfile_header.ClassCount],0
	    jz COutP_Print_EXIT_B

;main loop (goes through each instance only once - faster because
;           usually less class types than total instances)
;ebp = index
;[ebp-4] = end of buffer
;ebx = current instance

	mov edx,[COutP_CurrInstanceCount]
	mov esi,[COutP_MainBuffer]
	lea edx,[esi+4*edx]
	mov [ebp-4],edx 	 ;end-of-list delimiter
	COutP_Print_MAINLOOP:
	mov ebx,[esi]
	test ebx,ebx		 ;find next instance type
	     jz COutP_Print_MAINLOOP_SKIP_1

	     mov edx,[COutP_MaxInstanceCount]
	     shl edx,2
	     mov eax,[esi+edx]	;fetch instance's size
	     mov [ebp-8],eax

	     stdcall FindVTableCDDEntry,[ebx],[ebp-40]
	     test eax,eax    ;eax = CDD class entry for instance in ebx
	     mov edi,eax
		  jz COutP_Print_MAINLOOP_SKIP_1

	     mov ecx,[edi+vtable_desc.ClassLength]
	     test ecx,ecx
		  jz COutP_Print_MAINLOOP_CreateNewCDDDataSec
	     cmp ecx,[ebp-8]	     ;is class size the same? (should always be, but check anyway)
		 jnz COutP_Print_MAINLOOP_SKIP_1
	     push esi
	     mov edx,[edi+vtable_desc.ClassDataOffset]
	     mov esi,[ebp-40]
	     add edx,esi
	     call MixClassInfo
	     pop esi
	     jmp COutP_Print_MAINLOOP_No_CreateNewCDDDataSec
	     COutP_Print_MAINLOOP_CreateNewCDDDataSec:
	     ;edi = CDD class entry for instance in ebx - no class data section for this class, so create new from instance in ebx
	     mov ecx,[ebp-8]
	     push esi
	     mov esi,[ebp-40]
	     mov edx,[esi+outfile_header.FileEndOffset]
	     mov eax,edx
	     mov [edi+vtable_desc.ClassDataOffset],edx
	     mov [edi+vtable_desc.ClassLength],ecx
	     add eax,ecx
	     mov [esi+outfile_header.FileEndOffset],eax     ;extend file size (allocate space for class data, already NULL)
	     add edx,esi
	     call MixClassInfo	       ;(will do nothing if class size is less than 8 bytes)
	     pop esi
	     COutP_Print_MAINLOOP_No_CreateNewCDDDataSec:

	COutP_Print_MAINLOOP_SKIP_1:
	add esi,4
	cmp esi,[ebp-4]
	    jb COutP_Print_MAINLOOP

	invoke SetFilePointer,[ebp-32],0,0,FILE_BEGIN	;truncate file
	invoke SetEndOfFile,[ebp-32]

	mov esi,[ebp-40]
	lea edx,[ebp-12]
	mov ecx,[esi+outfile_header.FileEndOffset]
	invoke WriteFile,[ebp-32],esi,ecx,edx,0 	;write entire buffer

COutP_Print_EXIT_B:

	LOCALRELEASENONULL DWORD [ebp-40]
	CLOSEHANDLE DWORD [ebp-32]


pop ebx
pop edi
pop esi
mov esp,ebp
pop ebp

COutP_Print_EXIT:
ret

;============================================================
FindVTableCDDEntry:	;param1=VTable, param2=search buffer ('COTP')
;============================================================
;returns mem pointer in eax or null

	mov edx,[esp+8]
	mov eax,[esp+4]
	mov ecx,[edx+outfile_header.ClassCount]
	add edx,sizeof.outfile_header

	FindVTableCDDEntry_LOOP:
	cmp [edx+vtable_desc.VTable],eax
	    jz FindVTableCDDEntry_FOUND

	add edx,sizeof.vtable_desc
	dec ecx
	    jnz FindVTableCDDEntry_LOOP

	xor eax,eax
ret 8

FindVTableCDDEntry_FOUND:
	mov eax,edx
ret 8

;============================================================
MixClassInfo:
;============================================================
;edx = CDD class data section pointer (NULL spaces are considered undiscovered)
;ebx = instance (to mix with CDD class data for this instance type)
;ecx = instance total size
;esi = CDD buffer
;note: Some CDD VTable members do not have VTables. These are
;for the class names with no interfaces. They are still considered
;when treating inheritance patterns as long as the comparison
;implementation ignores the invalid VTable member and only compares
;strings or CDD VTable entries themselves. Apart from having no VTables,
;these CDD members have no class data and their inheritance
;values are valid but trivial (always contain only one reference, to themselves).
push ebx
push edi
	mov edi,edx

	cmp ecx,8
	    jb MixClassInfo_ExitPrem
	sub ecx,4
	and ecx,0FFFFFFFCh    ;compensate for possible extra bytes (round down/truncate to nearest DWORD)
	add ecx,edi
push ecx

	add ebx,4
	MixClassInfo_LOOP:
	mov eax,[edi]
	and eax,(CLASS_OUTPUTTER_COBJECT_ID+COUTP_CLASSENTRY_POINTER_INSTANCE)	 ;if there's already a pointer and it's a CObject, no point in going through inheritance patterns
	cmp eax,(CLASS_OUTPUTTER_COBJECT_ID+COUTP_CLASSENTRY_POINTER_INSTANCE)
	    jz MixClassInfo_ExitNewPointerSet

   ;first, check current DWORD member at [ebx] in instance to find most probable type
    ;check if we have a valid pointer, and if so:
     ;check if pointer points to space within same instance
       ;check if pointer points to a VTable
	 ;check if pointer points to a VTable found in the CDD list
       ;check if pointer points to a string
	  ;-> else, assume COUTP_CLASSENTRY_POINTER_SUBINSTANCE

     ;check if pointer points to an valid, different instance with a VTable found in the CDD list

     ;check if pointer points to a string
	  ;-> else, assume COUTP_CLASSENTRY_POINTER_MEMORY
    ;check if we have a VTable as member
    ;check if we have a string within the current member

	stdcall IsValidInstance,[ebx],4
	test eax,eax
	     jz MixClassInfo_InstanceMemberNotInstance
	mov eax,[ebx]
	stdcall FindVTableCDDEntry,[eax],esi
	test eax,eax		  ;does this VTable have an entry in the CDD?
	     jz MixClassInfo_InstanceMemberNotInstance




   ;second, check against previously stored type: set as new type if there was none,
   ;perform comparison and check if there is cause to modify stored type

	mov edx,[edi]
	and edx,(not COUTP_CLASSENTRY_CHECKALL)
	test edx,edx
	     jnz MixClassInfo_PointerAlreadyExists
	;here, simply replace pointer (if sub-instance has valid VTable - otherwise null)
	     sub eax,esi
	     or eax,COUTP_CLASSENTRY_POINTER_INSTANCE
	     mov [edi],eax	     ;store in CDD class data
	     jmp MixClassInfo_ExitNewPointerSet
	MixClassInfo_PointerAlreadyExists:
	;edx = current inheritance value (in CDD)
	;eax = new inheritance value (in CDD)
	;here, must find lowest inheritance between the two, or set as a CObject if there is none
	;-> simply comes down to comparing values in order, until the first
	;   match is made (CDD VTable entries are unique)
	     add edx,esi
	     mov edx,[edx+vtable_desc.InheritOffset]
	     add edx,esi
	     mov eax,[eax+vtable_desc.InheritOffset]
	     add eax,esi
	     stdcall FindFirstDWORDListMatch,edx,eax
	     test eax,eax
		  jnz MixClassInfo_PointerAlreadyExists_SKIP1  ;if no match, then we must use CObject
		  mov eax,CLASS_OUTPUTTER_COBJECT_ID
	     MixClassInfo_PointerAlreadyExists_SKIP1:
	     or eax,COUTP_CLASSENTRY_POINTER_INSTANCE
	     mov [edi],eax		;store in CDD class data (references are already relative to file start)
	MixClassInfo_ExitNewPointerSet:
	MixClassInfo_InstanceMemberNotInstance:

	add edi,4
	add ebx,4
	cmp edi,[esp]
	    jb MixClassInfo_LOOP

pop ecx

MixClassInfo_ExitPrem:

pop edi
pop ebx
ret


