;=========================================================
;Code for DirectDraw Video Mode Enumeration interception
;=========================================================

;=========================================================
INTERCEPTPROC DDRAWENUMCALLBACKINTRCPT_PROC1	  ;must preserve: none
;=========================================================

;print resolutions to ATX_LOGFILE
    cmp [UseOutputDDrawEnum],0
	jz NODDRAWMODEENUMINTERCEPT_PROC1

	mov edx,[DDRAWENUMRESCOUNT_1]
	mov edx,[edx]			;edx = resolution count in Tres buffer
	test edx,edx
	setle dl			;edx non-zero if count null
	cmp [OutputDDrawEnum_LastEnum],1
	mov al,0
	    jz DDRAWENUMCALLBACKINTRCPT_PROC1_IsLastEnum
	    mov al,1
	    mov [OutputDDrawEnum_LastEnum],1
	DDRAWENUMCALLBACKINTRCPT_PROC1_IsLastEnum:
	and dl,al

	mov eax,[esp+8] 	     ;DDSURFACEDESC2 struct instance
	mov ecx,[eax+DDSURFACEDESC2.dwRefreshRate]
	test [eax+DDSURFACEDESC2.dwFlags],DDSD_REFRESHRATE
	     jnz DDRAWENUMCALLBACKINTRCPT_PROC1_Refresh
	     xor ecx,ecx
	DDRAWENUMCALLBACKINTRCPT_PROC1_Refresh:

	stdcall DDRAWENUM_PRINTRESOLUTION,[eax+DDSURFACEDESC2.dwWidth],\
		[eax+DDSURFACEDESC2.dwHeight],\
		[eax+DDSURFACEDESC2.ddpfPixelFormat.dwRGBBitCount],\
		ecx,edx

    NODDRAWMODEENUMINTERCEPT_PROC1:

;add extra resolutions to list
	mov edx,[DDRAWENUMRESCOUNT_1]
	cmp DWORD [edx],0
	    jnle NoAddExtraResolutions_PROC1
	    mov edx,[esp+0Ch]	   ;edx points to base of structure for next resolution storage
	    call DDRAWENUM_COPYRESOLUTIONS
	    mov edx,[DDRAWENUMRESCOUNT_1]
	    mov [edx],eax
	NoAddExtraResolutions_PROC1:

	pop edx 	;return address
; /* REPLACED CODE
	mov ecx,[esp+4]
	cmp DWORD [ecx+54h],16		;(bit depth)
; */
	jmp edx

;=========================================================
INTERCEPTPROC DDRAWENUMCALLBACKINTRCPT_PROC2	  ;must preserve: eax
;=========================================================
push eax

;print resolutions to ATX_LOGFILE
    cmp [UseOutputDDrawEnum],0
	jz NODDRAWMODEENUMINTERCEPT_PROC2

	mov edx,[DDRAWENUMRESCOUNT_2]
	mov edx,[edx]			;edx = resolution count in Tres buffer
	test edx,edx
	setle dl			;edx non-zero if count null
	cmp [OutputDDrawEnum_LastEnum],2
	mov al,0
	    jz DDRAWENUMCALLBACKINTRCPT_PROC2_IsLastEnum
	    mov al,1
	    mov [OutputDDrawEnum_LastEnum],2
	DDRAWENUMCALLBACKINTRCPT_PROC2_IsLastEnum:
	and dl,al

	mov eax,[esp+12]	      ;DDSURFACEDESC2 struct instance
	mov ecx,[eax+DDSURFACEDESC2.dwRefreshRate]
	test [eax+DDSURFACEDESC2.dwFlags],DDSD_REFRESHRATE
	     jnz DDRAWENUMCALLBACKINTRCPT_PROC2_Refresh
	     xor ecx,ecx
	DDRAWENUMCALLBACKINTRCPT_PROC2_Refresh:

	stdcall DDRAWENUM_PRINTRESOLUTION,[eax+DDSURFACEDESC2.dwWidth],\
		[eax+DDSURFACEDESC2.dwHeight],\
		[eax+DDSURFACEDESC2.ddpfPixelFormat.dwRGBBitCount],\
		ecx,edx

    NODDRAWMODEENUMINTERCEPT_PROC2:

;add extra resolutions to list
	mov edx,[DDRAWENUMRESCOUNT_2]
	cmp DWORD [edx],0
	    jnle NoAddExtraResolutions_PROC2
	    add edx,0Ch   ;edx points to base of structure for next resolution storage
	    call DDRAWENUM_COPYRESOLUTIONS
	    mov edx,[DDRAWENUMRESCOUNT_2]
	    mov [edx],eax
	NoAddExtraResolutions_PROC2:

pop eax
	pop edx        ;return address
; /* REPLACED CODE
	test al,al
	mov eax,[esp+4]
; */
	jmp edx

align 16
;=========================================================
DDRAWENUM_PRINTRESOLUTION:  ;param1 = width, param2 = height, param3 = colors, param4 = refresh rate, param5 = BYTE boolean (print header?)
;=========================================================
push ebp
mov ebp,esp
sub esp,4
push ebx

	invoke CreateFile,LogFileName,GENERIC_WRITE,0,0,OPEN_ALWAYS,\
	       FILE_ATTRIBUTE_NORMAL,0
	cmp eax,-1
	mov ebx,eax
	    jz DDRAWENUM_PRINTRESOLUTION_EXIT

	invoke SetFilePointer,ebx,0,0,FILE_END

	cmp BYTE [ebp+24],0	   ;res count (if null, write header
	    jz DDRAWENUM_PRINTRESOLUTION_NOPRINTHEADER
	    lea edx,[ebp-4]
	    invoke WriteFile,ebx,DDRAWENUMOUT_Header_STR,(DDRAWENUMOUT_Header_STR_END-DDRAWENUMOUT_Header_STR),edx,0
	DDRAWENUM_PRINTRESOLUTION_NOPRINTHEADER:

	invoke wsprintf,stack_ext_buffer,DDRAWENUMOUT_Res_STR,[ebp+8],[ebp+12],[ebp+16],[ebp+20]
	add esp,6*4

	lea edx,[ebp-4]
	invoke WriteFile,ebx,stack_ext_buffer,eax,edx,0

	invoke CloseHandle,ebx

DDRAWENUM_PRINTRESOLUTION_EXIT:
pop ebx
mov esp,ebp
pop ebp
ret 20

align 16
;=========================================================
DDRAWENUM_COPYRESOLUTIONS:    ;edx = destination structure (assumed empty)
;=========================================================
;returns number of copied resolutions in eax
push esi
push edi

	mov esi,ForcedResolutionsBuffer
	xor eax,eax
	DDRAWENUM_COPYRESOLUTIONS_LOOP:
	mov ecx,[esi]
	mov edi,[esi+4]
	test ecx,ecx
	     jz DDRAWENUM_COPYRESOLUTIONS_LOOP_NORESOLUTION
	test edi,edi
	     jz DDRAWENUM_COPYRESOLUTIONS_LOOP_NORESOLUTION
	     mov [edx],ecx
	     mov [edx+4],edi	       ;third member is either bpp or refresh rate, and is already predetermined
	     inc eax
	DDRAWENUM_COPYRESOLUTIONS_LOOP_NORESOLUTION:

	add esi,8
	add edx,12
	cmp esi,ForcedResolutionsBuffer_END
	    jb DDRAWENUM_COPYRESOLUTIONS_LOOP

pop edi
pop esi
ret

;=========================================================
INTERCEPTPROC DDRAWREFRESHRATESSHOW_INTERCEPT	   ;must preserve: none
;=========================================================
;OBSOLETE: TRESPASSER DOES NOT SET VIDEO MODES WITH SPECIFIC
;REFRESH RATES PROPERLY EVEN THOUGH IT CAN ENUMERATE THEM
;IN ONE OF THE MENUS.

	pop ecx 	;return address
	mov DWORD [stack_ext_buffer],ecx

	push [DDRAWENUMPROC_1]
	push edx
	mov ecx,[eax]
	push ebx
	push DWORD DDEDM_REFRESHRATES
	push eax
	jmp DWORD [stack_ext_buffer]

align 16
;=========================================================
AdjustCameraFOVWidescreen:
;=========================================================
	mov eax,[AT06_CameraFOV_Value]
	mov ecx,RenderTempObj2
	test eax,eax
	     jz NO_AdjustCameraFOVWidescreen

	mov [ecx+10h],eax
	mov eax,[CSETRENDERERACTIONVTABLE]
	mov DWORD [ecx+4h],0
	mov DWORD [ecx+8h],2
	mov [ecx],eax
	call DWORD [eax+8]

NO_AdjustCameraFOVWidescreen:
ret

