;====================================================================
;NEW BACKGROUND IMAGE LOADER
;====================================================================
;all registers except edx must be preserved if no new TGA file to set
;eax = GetFileAttributes param (string)
;ecx = string length

;note: the index used to reference the "li_levelname" TGA filenames
;internally by the EXE is found at DWORD [esp+0Ch] upon call to this proc.
;A value of 00000009 indicates the default TGA file (lower indexes determine
;the default level TGA files).

LEVELLOADBG_PROC_EXT:	 ;return address at [esp+124h] (including call to this proc)
	mov edx,[esp+124h]
	cmp edx,[LOADBGFILE_RET_ADDR]
	    jnz NO_LEVELLOADBG_PROC_EXT

push edi
	mov edi,[MapsPathSize]
push esi
	add edi,MapsDirBuffer
	mov esi,[LEVELNAME_OBJ]
	mov DWORD [edi],'LBG\'
push ebx
	add edi,4
push ecx
push eax
	mov ebx,edi
	call TransferString
	mov DWORD [edi-4],'.tga'

	mov esi,MapsDirBuffer
	invoke FindFirstFile,esi,find_data_buf

	cmp eax,INVALID_HANDLE_VALUE	;does LEVELNAME.tga exist in 'MAPS\LBG\' ?
	    jnz NewLevelLoadBGFound

	    cmp DWORD [esp+20h],00000009      ;default default image? (intentional repetition)
		jnz LoadPreviousBGImageOnly

	    mov DWORD [ebx],'defa'
	    mov DWORD [ebx+4],'ult.'
	    mov DWORD [ebx+8],00616774h       ;'tga' + null terminator

	    invoke FindFirstFile,esi,find_data_buf
	    cmp eax,INVALID_HANDLE_VALUE
		jz LoadPreviousBGImageOnly

	NewLevelLoadBGFound:

	invoke FindClose,eax

	;esi = MapsDirBuffer
	mov edi,[esp]		  ;set new TGA file as background file (in local mem)
	call TransferString

	mov edx,[MapsPathSize]
	mov BYTE [edx+MapsDirBuffer],0

pop eax
pop ecx
pop ebx
pop esi
pop edi

mov edx,[esp]
mov [esp],eax	      ;GetFileAttributes param
jmp edx

;------------------------------
LoadPreviousBGImageOnly:
;------------------------------
	mov edx,[MapsPathSize]
	mov BYTE [edx+MapsDirBuffer],0

pop eax
pop ecx
pop ebx
pop esi
pop edi

;------------------------------
NO_LEVELLOADBG_PROC_EXT:
;------------------------------
mov edx,[esp]	      ;return address
;/* REPLACED CODE
and ecx,3
mov [esp],eax	      ;GetFileAttributes param
repz movsb
;*/
jmp edx







