;===========================================================
;RAY CASTING-ASSOCIATED FUNCTIONS
;===========================================================

align 16
DoRayCastAimdotUpdate:

	mov [THIRDP_aimdot_lastobj],0

	mov edi,stack_ext_buffer

;check if player is holding gun, and if so, get instance
	mov ecx,GETWEAPON_PRIMARY
	call GetHeldWeaponInstance
	test eax,eax
	mov esi,eax
	    jz DoRayCastAimdotUpdate_EXIT

       ;esi = CGun object

       ;get starting location for raycast
       ;This is basically copied from the executable for consistency.
       ;The game uses the CONVERT_TO_FACING proc with "base vector"
       ;different from [0.0, 1.0, 0.0]. Could not figure out why.
       ;"base vector" is gotten directly from CGun object.
       ;The game also treats quaternion W value 1.00000 differently.
       ;Must be a "key" value. Don't know if this is required or if is
       ;for optimization.

	mov eax,[esi+3Ch]		   ;keep same orientation as gun
	mov edx,[esi+40h]
	mov [RayCast_SourceQuatW],eax
	mov [RayCast_SourceQuatX],edx
	mov eax,[esi+44h]
	mov edx,[esi+48h]
	mov [RayCast_SourceQuatY],eax
	mov [RayCast_SourceQuatZ],edx

	fld [RayCast_SourceQuatW]
	fcomp [float_one]
	fstsw ax
	test ah,40h	       ;if Quat.W is equal to 1.000000, use vector alone
	     jne DoRayCastAimdotUpdate_UseVector
	     lea eax,[esi+74h]		     ;"base vector"
	     lea edx,[RayCast_TempVectorX]   ;destination
	     lea ecx,[RayCast_SourceQuatW]
	     stdcall [PTRCONVERT_TO_FACING_PROC_2A],edx,eax
	jmp DoRayCastAimdotUpdate_SkipVector
	DoRayCastAimdotUpdate_UseVector:
	     mov eax,[esi+74h]
	     mov ecx,[esi+78h]
	     mov edx,[esi+7Ch]
	     mov [RayCast_TempVectorX],eax
	     mov [RayCast_TempVectorY],ecx
	     mov [RayCast_TempVectorZ],edx
	DoRayCastAimdotUpdate_SkipVector:

	fld DWORD [esi+4Ch]		       ;length value in CGun object (?)
	fld [RayCast_TempVectorX]
	fmul st0,st1
	fld [RayCast_TempVectorY]
	fmul st0,st2
	fld [RayCast_TempVectorZ]
	fmul st0,st3
	fadd DWORD [esi+CInstance.Location.Z]
	fst [THIRDP_aimdot_sourcez]
	fstp [RayCast_SourcePosZ]	       ;store starting position for ray cast
	fadd DWORD [esi+CInstance.Location.Y]
	fst [THIRDP_aimdot_sourcey]
	fstp [RayCast_SourcePosY]
	fadd DWORD [esi+CInstance.Location.X]
	fst [THIRDP_aimdot_sourcex]
	fstp [RayCast_SourcePosX]
	fstp st0

	mov eax,[esi+4Ch]
	mov [RayCast_UnknownParam],eax

	lea ecx,[RayCast_PrivateStrucPointerHold]
	push DWORD [esi+50h]		;gun Range value
	push DWORD 0.001
	push edi
	call [RayCastProcGetIntersect]
   DoRayCastAimdotUpdate_GetNextIntersect:
	lea ecx,[RayCast_PrivateStrucPointerHold]
	call [RayCastProcGetPrivate]
	test eax,eax
	     jz DoRayCastAimdotUpdate_EXIT_WFree   ;did we have an intersect? (can be more than one in structure; RayCastProcGetPrivate should return first found)
	mov ecx,[eax+20h]
	cmp ecx,esi
	    jz DoRayCastAimdotUpdate_GetNextIntersect	 ;did we hit same CGun instance? If so, try next intersect

	mov [THIRDP_aimdot_lastobj],ecx
	mov ebx,[eax]
	mov ecx,[eax+4]
	mov edx,[eax+8]
	mov [THIRDP_aimdot_lastx],ebx
	mov [THIRDP_aimdot_lasty],ecx
	mov [THIRDP_aimdot_lastz],edx

DoRayCastAimdotUpdate_EXIT_WFree:
	lea ecx,[RayCast_PrivateStrucPointerHold]
	call [RayCastProcFree]

DoRayCastAimdotUpdate_EXIT:
ret